#include <stdio.h>
#include <algorithm>
#include <vector>
#include <iostream>

int n, f;
double s[100005];
int next[100005];
int prev[100005];
int speed[100005];
double last_time[100005];
bool ok[100005];
int done;

using namespace std;

struct hi {
	int pos;
	double time;
};

bool comp(hi a, hi b)
{
	return a.time > b.time;
}

int l = 0;
vector<hi> heap;

int main(){
	while(scanf("%d %d", &n, &f)>=0){
		int a;
		hi h, j;
		heap.clear();
		for(int i=0;i<n;i++){
			scanf("%d", &a);
			speed[i] = f;
			s[i] = (double)a;
			h.pos = i;
			last_time[i] = 0.0;
			h.time = (double)s[i]/f;
			next[i] = i+1;
			prev[i] = i-1;
			ok[i] = false;
			heap.push_back(h);
			push_heap(heap.begin(),heap.end(), comp);
		}
		
		next[n-1] = n-1;
		prev[0] = 0;
		done = 0;
		double done_time;
		double end_time;
		while(done < n)
		{
			h = heap.front();
			//cout<<heap.front().pos<<" "<<heap.front().time<<endl;
			pop_heap(heap.begin(), heap.end(), comp);
			heap.pop_back();
			if(ok[h.pos])
				continue;
			ok[h.pos] = true;
			done++;
			if(done == n)
				done_time = h.time;
			if(h.pos == n-1)
				end_time = h.time;
			next[prev[h.pos]] = next[h.pos];
			s[next[h.pos]] = s[next[h.pos]]-speed[next[h.pos]]*(h.time-last_time[next[h.pos]]);
			last_time[next[h.pos]] = h.time;
			speed[next[h.pos]] += speed[h.pos];
			//cout<<s[next[h.pos]]<<endl;
			j.pos = next[h.pos];
			j.time = h.time+s[next[h.pos]]/speed[next[h.pos]];
			heap.push_back(j);
			push_heap(heap.begin(), heap.end(), comp);
		}
		cout<<end_time<<" "<<done_time<<endl;
	}
}
